/*------------------------------------------------------------------------------
 bin/djv_view/image_color.h
 
 Image Color
 -----------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VIEW_IMAGE_COLOR_H
#define DJV_VIEW_IMAGE_COLOR_H

#include <djv_ui/dialog.h>
#include "base.h"

namespace djv_view {
namespace image_color
{

//------------------------------------------------------------------------------
// Dialog

class Dialog : public ui::dialog::Base
{
public:
  
  Dialog();
  
  void set(ui::Signal<const Color &> *);
  
  ui::Signal<const Color &> sig;
  
private:

  DJV_CALLBACK(Dialog, widget_callback, const Color &);
  DJV_CALLBACK(Dialog, lut_callback, const File &);
  DJV_CALLBACK(Dialog, brightness_callback, double);
  DJV_CALLBACK(Dialog, contrast_callback, double);
  DJV_CALLBACK(Dialog, saturation_callback, double);
  DJV_CALLBACK(Dialog, levels_in0_callback, double);
  DJV_CALLBACK(Dialog, levels_in1_callback, double);
  DJV_CALLBACK(Dialog, gamma_callback, double);
  DJV_CALLBACK(Dialog, levels_out0_callback, double);
  DJV_CALLBACK(Dialog, levels_out1_callback, double);
  DJV_CALLBACK(Dialog, soft_clip_callback, double);
  DJV_CALLBACK(Dialog, close_callback, bool);

  void widget_update();
  
  Color _value;
  ui::file::Widget * _lut;
  ui::num::Float_Slider * _brightness, * _contrast, * _saturation;
  ui::num::Float_Slider * _levels_in [2], * _gamma, * _levels_out [2],
    * _soft_clip;
};

//------------------------------------------------------------------------------
// Global

Dialog * dialog();

void del();

}
}

#endif

