/*------------------------------------------------------------------------------
 bin/djv_vlut/app.h

 Application
 -----------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VLUT_APP_H
#define DJV_VLUT_APP_H

#include <djv_image/io.h>
#include <djv_ui/app.h>
#include "window.h"

namespace djv_vlut
{

//------------------------------------------------------------------------------
// Application

class App : public ui::App
{
public:

  App(int & argc, char ** argv);
  ~App();
  
private:

  DJV_CALLBACK(App, color_callback, const Color &);
  
  void color_update();

  void cmdln() throw (Error);
  Str help() const;

  Str _input;
  Color _color;
  List<Color> _color_list;
  ui::Signal<bool> _color_list_sig;
  std::auto_ptr<image::io::Save> _save;
  image::Image _image, _image_tmp;
  window::Widget * _window;
};

}

#endif

