/*------------------------------------------------------------------------------
 lib/djv_base/dir.h
 
 File System Directories
 -----------------------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_DIR_H
#define DJV_DIR_H

#include <djv_base/file.h>

namespace djv {
namespace dir
{

//------------------------------------------------------------------------------
// Directory

class Dir
{
public:

  Dir();
  Dir(const Str &);

  // Value.
  
  void set(const Str &);
  const Str & get() const { return _path; }
  bool valid() const { return _valid; }
  List<File> list() const;

  // Functions.
  
  void cd(const Str &);
  void up();

private:

  void update();
  
  Str _path;
  bool _valid;
};

//------------------------------------------------------------------------------
// Functions

Str desktop();
#if ! defined(WIN32)
Str home();
#endif

#if defined(WIN32)
List<Str> drive_list();
#else
Str root();
#endif



}
}

#endif

