/*------------------------------------------------------------------------------
 lib/djv_base/error.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "error.h"
#include <djv_base/str.h>

namespace djv {
namespace error
{

Error::Error() {}
Error::Error(const Str & in) : _str(in) {}
Error::Error(const Str & prefix, const Str & in) : _str(prefix + " " + in) {}

Str format(const Error & in)
{
  return str::Format("ERROR %1").arg(in.str());
}

void print(const Error & in)
{
  ::printf("%s\n", format(in).c_str());
}

}
}

