/*------------------------------------------------------------------------------
 lib/djv_base/error.h
 
 Errors
 ------
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_ERROR_H
#define DJV_ERROR_H

#include <djv_base/list.h>

namespace djv {
namespace error
{

//------------------------------------------------------------------------------
// Error

class Error
{
public:

  Error();
  Error(const Str &);
  Error(const Str & prefix, const Str &);
  
  const Str & str() const { return _str; }
  
  operator Str () const { return _str; }
  
private:

  Str _str;
};

//------------------------------------------------------------------------------
// Functions

Str format(const Error &);

void print(const Error &);

}
}

#endif

