/*------------------------------------------------------------------------------
 lib/djv_base/file_seq.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_base/file_seq.cxx"

#include "file.h"

namespace djv {
namespace file
{

void seq_compress(List<File> * in)
{
  //DJV_DBG_OBJ2(_DBG, "seq_compress");
  //DJV_DBG_PRN("size = " << in->size());
  
  List<File> & list = *in;
  int cache = -1;
  uint i = 0;
  for (uint j = 0; j < list.size(); ++j)
  {
    //DJV_DBG_PRN("item = " << list[j]);
    
    const bool seq = list[j].seq_valid();
    if (seq)
    {
      if (cache != -1)
        if (list[cache].seq_add(list[j])) continue;
      
      cache = -1;
      for (uint k = 0; k < i; ++k)
      {
        if (SEQ == list[k].type)
          if (list[k].seq_add(list[j]))
          {
            cache = k;
            continue;
          }
      }
    }
    
    if (! seq || -1 == cache)
    {
      list[i] = list[j];
      if (seq) list[i].type = SEQ;
      ++i;
    }
  }
  //DJV_DBG_PRN("size = " << i);
  list.resize(i);
}

}
}

