/*------------------------------------------------------------------------------
 lib/djv_image/base.h
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_IMAGE_BASE_H
#define DJV_IMAGE_BASE_H

#include <djv_base/base.h>
#include <GL/glew.h>
#if defined(WIN32)
#include <GL/wglew.h>
#elif defined(DJV_OSX)
#else
#include <GL/glxew.h>
#endif

namespace djv {
namespace image
{

//------------------------------------------------------------------------------
// Declarations

namespace color { class Color; }
namespace data { class Info; class Data; }
using color::Color;
using data::Info;
using data::Data;

namespace tag { class Tag; }
namespace profile { class Profile; }
using tag::Tag;
using profile::Profile;

namespace gl
{
namespace offscreen { class Pbuffer; }
namespace data { class Options; class Data; }
}

class Image;

namespace time { class Time; }
using time::Time;

namespace io
{
class Plugin;
class Load;
class Save;
class Load_Factory;
class Save_Factory;
}

namespace app { class App; }
using app::App;

}
}

#endif

