/*------------------------------------------------------------------------------
 lib/djv_image/gl_offscreen_agl.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_image/gl_offscreen_agl.cxx"

#include "gl_offscreen.h"
#include <djv_base/vec.h>

namespace djv {
namespace image {
namespace gl {
namespace offscreen
{

namespace
{

class _Pbuffer
{
public:

  _Pbuffer(const Vec2i & size, void * context_share) throw (Error);
  ~_Pbuffer();
  
  void current() throw (Error);
  
  const Vec2i & size() const { return _size; }
  void * context_share() const { return 0; }
  
private:

  Vec2i _size;
};

class _Pbuffer_Factory
{
public:

  _Pbuffer_Factory() throw (Error);
  ~_Pbuffer_Factory();
  
  void add(_Pbuffer *);
  
  _Pbuffer * get(const Vec2i & size, void * context_share) throw (Error);
  
private:

  List<_Pbuffer *> _list;
};

std::auto_ptr<_Pbuffer_Factory> _factory;

_Pbuffer::_Pbuffer(const Vec2i & size, void * context_share) throw (Error)
{
}

_Pbuffer::~_Pbuffer()
{
}

void _Pbuffer::current() throw (Error)
{
}

_Pbuffer_Factory::_Pbuffer_Factory() throw (Error)
{
}

_Pbuffer_Factory::~_Pbuffer_Factory()
{
}

void _Pbuffer_Factory::add(_Pbuffer * in)
{
}

_Pbuffer * _Pbuffer_Factory::get(const Vec2i & size, void * context_share)
  throw (Error)
{
  return 0;
}

}

class Pbuffer::Context_Restore
{
public:

  Context_Restore() {}
  
  ~Context_Restore() throw (Error) {}
  
private:
};

Pbuffer::Pbuffer(const Vec2i & size, void * context_share) throw (Error) :
  _p(0),
  _context_restore(new Context_Restore)
{
}

Pbuffer::~Pbuffer()
{
}

const Vec2i & Pbuffer::size() const { return _p->size(); }

void init() throw (Error)
{ _factory = std::auto_ptr<_Pbuffer_Factory>(new _Pbuffer_Factory); }
void del() { _factory.reset(); }

}
}
}
}

