/*------------------------------------------------------------------------------
 lib/djv_image/pixel_fnc.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "pixel.h"

namespace djv {
namespace image {
namespace pixel
{

bool serialize(List<Str> * in, PIXEL * out)
{
  FORMAT format = FORMAT(0);
  TYPE type = TYPE(0);
  if (! str::serialize(in, &format, label_format())) return false;
  if (! str::serialize(in, &type, label_type())) return false;
  if (! pixel(format, type, out)) return false;
  return true;
}

List<Str> serialize(const PIXEL & in)
{
  return List<Str>() << label_format()[format(in)] << label_type()[type(in)];
}

const List<Str> & label_format()
{
  static const List<Str> data = List<Str>() << "L" << "LA" << "RGB" << "RGBA";
  return data;
}

const List<Str> & label_type()
{
  static const List<Str> data = List<Str>() << "U8" << "U10" << "U16" <<
    "F16" << "F32";
  return data;
}

const List<Str> & label_pixel()
{
  static const List<Str> data = List<Str>() <<
    "L U8" << "L U16" << "L F16" << "L F32" <<
    "LA U8" << "LA U16" << "LA F16" << "LA F32" <<
    "RGB U8" << "RGB U10" << "RGB U16" << "RGB F16" << "RGB F32" <<
    "RGBA U8" << "RGBA U16" << "RGBA F16" << "RGBA F32";
  return data;
}

Dbg & operator << (Dbg & dbg, FORMAT in) { return dbg << label_format()[in]; }
Dbg & operator << (Dbg & dbg, TYPE in) { return dbg << label_type()[in]; }
Dbg & operator << (Dbg & dbg, PIXEL in) { return dbg << label_pixel()[in]; }

}
}
}

