/*------------------------------------------------------------------------------
 lib/djv_ui/scroll.h
 
 Scroll Widget
 -------------

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_SCROLL_H
#define DJV_UI_SCROLL_H

#include <djv_ui/widget.h>
#include <FL/Fl_Scroll.H>

class Fl_Box;

namespace djv {
namespace ui {
namespace scroll
{

//------------------------------------------------------------------------------
// Widget

class Widget : public Fl_Scroll, public widget::Base
{
public:

  Widget();
  virtual ~Widget() {}
  
  // Widget.
  
  virtual int handle(int);
  virtual void draw();
  
  // Layout.

  void resizable(bool);
  bool resizable() const { return _resizable; }

  virtual void dirty();
  virtual void geom(const Box2i &);
  virtual const Box2i & geom() const { return widget::Base::geom(); }
  virtual void resize(int x, int y, int w, int h) { geom(Box2i(x, y, w, h)); }
  virtual const Vec2i & size_min() const { return _size_min; }
  virtual int visible() const { return Fl_Scroll::visible(); }
  
  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::scroll::Widget"; }

private:

  bool _resizable;
  Fl_Box * _dummy_widget;
  Vec2i _size_min;
};

}
}
}

#endif

