/*------------------------------------------------------------------------------
 lib/djv_ui/vec.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "vec.h"
#include <djv_ui/layout_row.h>
#include <djv_ui/num_int.h>
#include <djv_ui/num_float.h>

namespace djv {
namespace ui {
namespace vec
{

Vec2i::Vec2i()
{
  _widget = new num::Int_Edit;
  _widget2 = new num::Int_Edit;
  
  size(layout::FIXED, layout::FIXED);
  align(layout::LEFT, layout::CENTER);
  
  layout::Horizontal * layout = new layout::Horizontal(this);
  layout->margin(0);
  layout->add(_widget);
  layout->add(_widget2);

  widget_update();
  
  _widget->sig.set(this, widget_callback);
  _widget2->sig.set(this, widget2_callback);
}
  
void Vec2i::set(const djv::Vec2i & in)
{
  if (in == _value) return;
  _value = in;
  widget_update();
  sig.emit(_value);
}

void Vec2i::widget_callback(int in) { set(djv::Vec2i(in, _value.y)); }
void Vec2i::widget2_callback(int in) { set(djv::Vec2i(_value.x, in)); }

void Vec2i::widget_update()
{
  callbacks(false);
  _widget->set(_value.x);
  _widget2->set(_value.y);
  callbacks(true);
}

Vec2f::Vec2f()
{
  _widget = new num::Float_Edit;
  _widget2 = new num::Float_Edit;
  
  size(layout::FIXED, layout::FIXED);
  align(layout::LEFT, layout::CENTER);
  
  layout::Horizontal * layout = new layout::Horizontal(this);
  layout->margin(0);
  layout->add(_widget);
  layout->add(_widget2);

  widget_update();
  
  _widget->sig.set(this, widget_callback);
  _widget2->sig.set(this, widget2_callback);
}

void Vec2f::set(const djv::Vec2f & in)
{
  if (in == _value) return;
  _value = in;
  widget_update();
  sig.emit(_value);
}

void Vec2f::widget_callback(double in) { set(djv::Vec2f(in, _value.y)); }
void Vec2f::widget2_callback(double in) { set(djv::Vec2f(_value.x, in)); }

void Vec2f::widget_update()
{
  callbacks(false);
  _widget->set(_value.x);
  _widget2->set(_value.y);
  callbacks(true);
}

}
}
}
