/*------------------------------------------------------------------------------
 plugin/djv_vlut/fnc.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "plugin/djv_vlut/fnc.cxx"

#include "plugin.h"

#if defined(DJV_VLUT_WIN32)

Handle::Handle() throw (Error) : display(0)
{
  DJV_DBG_OBJ2(_DBG, "Handle::Handle");

  display = ::GetDC(0);
  if (! display)
    throw Error(name, image::io::error_open);
}

Handle::~Handle()
{
  if (display) ::ReleaseDC(0, display);
}

namespace { std::auto_ptr<Handle> _handle; }

Handle * handle()
{
  if (! _handle.get()) _handle = std::auto_ptr<Handle>(new Handle);
  return _handle.get();
}

#endif

