#define DJV_DBG

#include <djv_base/file.h>

using namespace djv;

const struct Split_Test {
  Str in, path, base, number, extension;
} split_test [] = {
  { "/tmp/image.1-100.tiff", "/tmp/", "image.", "1-100", ".tiff" },
  { "image.1-100.tiff", "", "image.", "1-100", ".tiff" },
  { "image.001-100.tiff", "", "image.", "001-100", ".tiff" },
  { "image1-100.tiff", "", "image", "1-100", ".tiff" },
  { "image001-100.tiff", "", "image", "001-100", ".tiff" },
  { "1-100.tiff", "", "", "1-100", ".tiff" },
  { "-1.tiff", "", "", "-1", ".tiff" },
  { "1-100", "", "", "1-100", "" },
  { "1", "", "", "1", "" },
  { ".hidden", "", ".hidden", "", "" },
  { "/", "/", "", "", "" },
  { "//", "//", "", "", "" },
  { "/.", "/", "", "", "." },
  { "./", "./", "", "", "" } };
const int split_test_size = sizeof(split_test) / sizeof(Split_Test);

int main(int argc, char ** argv)
{
  DJV_DBG_OBJ("file");
  
  for (int i = 0; i < split_test_size; ++i)
  {
    File tmp(split_test[i].in);
    DJV_DBG_PRN("split: " << split_test[i].in << " = " <<
      str::Format("'%1' '%2' '%3' '%4'").arg(tmp.path()).arg(tmp.base()).
        arg(tmp.number()).arg(tmp.extension()));
    if (tmp.path() != split_test[i].path ||
      tmp.base() != split_test[i].base ||
      tmp.number() != split_test[i].number ||
      tmp.extension() != split_test[i].extension
    ) return 1;
  }
}
