//#define DJV_DBG

#include <djv_ui/layout_row.h>
#include <djv_ui/label.h>
#include <djv_ui/choice.h>
#include <djv_ui/window.h>
#include <djv_ui/app.h>

namespace
{
using namespace djv;

class App : public ui::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, callback, int)
    { print(str::Format("choice = %1").arg(in)); }
  DJV_CALLBACK(App, callback2, int)
    { print(str::Format("choice 2 = %1").arg(in)); }
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  ui::App("choice", argc, argv),
  _window(0)
{
  DJV_DBG_OBJ("App::App");
  
  const List<Str> data = List<Str>() << "MacReady" << "Blair" << "Nauls" <<
    "Palmer" << "Clark";
  
  // Widgets.
  
  ui::choice::Widget * widget = new ui::choice::Widget(data);
  widget->label(new ui::label::Widget("Human:"));
  
  ui::choice::Widget * widget2 = new ui::choice::Widget(data);
  widget2->label(new ui::label::Widget("Thing:"));

  _window = new ui::window::Widget(name());
  
  // Layout.
  
  ui::layout::group(List<ui::layout::Item *>() << widget << widget2);

  ui::layout::Vertical * layout = new ui::layout::Vertical(_window);
  layout->add(widget);
  layout->add(widget2);
  
  // Initialize.

  valid(true);
  
  _window->size(_window->size_hint());
  _window->show();

  // Callbacks.
  
  widget->sig.set(this, callback);
  widget2->sig.set(this, callback2);
  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->widget_del();
}

}

int main(int argc, char ** argv) { return ::App(argc, argv).exec(); }
